%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%        Regressio llei de tensio normal a una       %%%%%%%%%%%%%%%%
%%%%%%  seccio rectangular i calcul de valors interpolats %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%carrega arxiu amb valor de la tensio normal als punts de gauss. %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
arxiu=input('nom arxiu  .prsm: ');
[hdcc,obs]=hdrload(arxiu);
elem_gruix=input('quants elements te el gruix: ');
elem_llarg=input('quants elements te el llarg: ');
ngauss=input('quants punts de gauss te la llei d_integracio: ');
cantell=0.2;%input('cantell(m): ');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Ens quedem amb els elements centrals %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elem_centrals=[];
obs_pila=[];
elem_centrals(1)=(elem_llarg+1)/2;
for i=2:elem_gruix
elem_centrals(i)=elem_centrals(i-1)+elem_llarg;
end

for i=1:elem_gruix
obs_pila(i*ngauss-(ngauss-1):i*ngauss,:)=obs(elem_centrals(i)*ngauss-(ngauss-1):(elem_centrals(i)*ngauss),2:3);
end
v=zeros(ngauss*elem_gruix/2,1)
v(1)=1;
for i=2:ngauss*elem_gruix/2;
    v(i)=v(i-1)+2;
end
obs_pila=obs_pila(v,:)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Interpolacio dels valors del calcul a tota la seccio %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
zgauss=obs_pila(:,1)-0.1;
sigma_x=obs_pila(:,2);
b=regress(sigma_x,zgauss);
pas=100
z_int=linspace(0.1,-0.1,pas)';
sigma_int=b.*z_int;
b_ana=sigma_analitica(cantell)
sigma_ana=b_ana.*z_int;
error_rel=(abs(sigma_ana-sigma_int))./(abs(sigma_ana));
error_abs=(abs(sigma_ana-sigma_int));

fig=figure(1);
subplot(1,2,1)
plot(zgauss,sigma_x,'b+');
hold on
plot(z_int,sigma_int,'go--');
hold on
plot(z_int,sigma_ana,'r--');
legend('Valors de calcul FEM en pdG','Interpolacio linial valors de calcul','Solucio analitica',3);
xlabel('cantell (m)');
ylabel('sigma X (N/m2)');
axis tight
titol=sprintf('VIGA 2D: 420x20(cm) Solucio FEM vs ANALITICA. \n Cas %i divisions al gruix i %i elem. al llarg ',elem_gruix,elem_llarg);
title(titol); 
sigma_max_int= sprintf('sigma MAX   (calcul) : %10.2f N/m/m',max(sigma_int));
sigma_max_ana= sprintf('sigma MAX (analitica): %10.2f N/m/m',max(sigma_ana));
text(-0.03,0.8e6,{sigma_max_int,sigma_max_ana},'FontName','arial','Fontsize',10);
hold off

subplot(1,2,2)
plot(z_int,error_rel,'b-');
xlabel('cantell (m)');
ylabel('error relatiu, (valors numerics int.-analitics)/analitics');
title('Error relatiu entre solucio numerica i analitica');
grid on


result=[z_int(:) sigma_int(:)];
fid1=fopen('interpolats.res','w');
for i=1:pas
    fprintf(fid1,'%8.5f   %15.5f   \r\n', result(i,:)');
end
fclose(fid1);