clear all;
%carreguem les diferents matrius dels arxius DRAC
[titol,A]=hdrload('calcul_DRAC3x21g2x2 QUAD.prsm');
gruix=0.2;

num_prism=(length(A(:,1)))/4;
for i=1:num_prism
    gauss_elem1(i,:)=A(4*i-3:(4*i-3)+1,2)';
    gauss_elem2(i,:)=A(4*i-1:(4*i-1)+1,2)';
    M_tensio_elem1(i,:)=A(4*i-3:(4*i-3)+1,3)';
    M_tensio_elem2(i,:)=A(4*i-1:(4*i-1)+1,3)';
    Q_tensio_elem1(i,:)=A(4*i-3:(4*i-3)+1,5)';
    Q_tensio_elem2(i,:)=A(4*i-1:(4*i-1)+1,5)';
    
end
elemppila=3;
num_piles=num_prism/elemppila;
for ipila=1:num_piles;
    piles(ipila,:)=[ipila ipila+num_piles ipila+2*num_piles];
end

%Obre arxius per escriure els resultats;
%f1=fopen('Axil.res','w');
%fprintf(f1,'Components del tensor d esforos AXILS 3D_eixos GLOBALS\r\n');
f2=fopen('Flector.res','w');
fprintf(f2,'Components del tensor de MOMENTS 3D_eixos GLOBALS\r\n');
%f3=fopen('Cortante.res','w');
%fprintf(f3,'vector n_unit(1)\r\n');

for ipila=1:num_piles
    gauss_pila=zeros(6,2);
    M_tensio_pila=zeros(6,2);
    Q_tensio_pila=zeros(6,2);
        for j=1:elemppila
              
        gauss_pila(2*j-1,:)  = [gauss_elem1(piles(ipila,j),:)];
        gauss_pila(2*j,:)    = [gauss_elem2(piles(ipila,j),:)];
        M_tensio_pila(2*j-1,:) = [M_tensio_elem1(piles(ipila,j),:)];
        M_tensio_pila(2*j,:)   = [M_tensio_elem2(piles(ipila,j),:)];
        Q_tensio_pila(2*j-1,:) = [Q_tensio_elem1(piles(ipila,j),:)];
        Q_tensio_pila(2*j,:)   = [Q_tensio_elem2(piles(ipila,j),:)];
        
    end
    

%inicialitzem vectors
%int_N=[];
int_M=[];
int_Q=[];
%parametres
gruix_el=gruix/elemppila;
lim_sup=gruix/2;
lim_inf=-gruix/2;
z_gauss=[-0.57735 0.57735];

for i=1:elemppila
  %agafem les tensions de l'element de la pila.
  sigma_gauss1=M_tensio_pila(2*i-1,:);
  sigma_gauss2=M_tensio_pila(2*i,:);
  Q_sigma_gauss1=Q_tensio_pila(2*i-1,:);
  Q_sigma_gauss2=Q_tensio_pila(2*i,:);
    %expressio del canvi de variable per cada element de la pila i.
  inf_el=lim_inf+(i-1)*gruix_el;
  sup_el=lim_inf+i*gruix_el;
  b=(inf_el+sup_el)/2;
  a=sup_el-b;
  %esforos de membrana N.
  N_sigma=[sigma_gauss1; sigma_gauss2]';
  int_N(:,i)=a*(N_sigma(:,1)+N_sigma(:,2));
  %moments flectors M.
 M_sigma=[sigma_gauss1; sigma_gauss2];
 int1=a*((z_gauss*M_sigma)');
 M_sigma=M_sigma';
 int2=b*(M_sigma(:,1)+M_sigma(:,2));
 int_M(:,i)=a*(int1+int2);
 %tallants Q.
 Q_sigma=[Q_sigma_gauss1; Q_sigma_gauss2]';
 int_Q(:,i)=a*(Q_sigma(:,1)+Q_sigma(:,2));
end
M(ipila,:)=[(int_M(:,1)+int_M(:,2)+int_M(:,3))'];
Q(ipila,:)=[(int_Q(:,1)+int_Q(:,2)+int_Q(:,3))'];
N(ipila,:)=[(int_N(:,1)+int_N(:,2)+int_N(:,3))'];
M_plot(2*ipila-1)=M(ipila,2);
M_plot(2*ipila)=M(ipila,1);
Q_plot(2*ipila-1)=Q(ipila,2);
Q_plot(2*ipila)=Q(ipila,1);
N_plot(2*ipila-1)=N(ipila,2);
N_plot(2*ipila)=N(ipila,1);
x_gauss(2*ipila-1)=0.042+0.2*(ipila-1);
x_gauss(2*ipila)=0.1577+0.2*(ipila-1);
end
 M_ana=-(3600/2).*x_gauss.*(4.2 - x_gauss);
 Q_ana=(-(3600*4.2)/2)+3600.*x_gauss;

fig=figure(1);
plot(x_gauss,M_plot,'bx');
hold on
plot(x_gauss,M_ana,'go--');
legend('Valors de calcul FEM en pdG','Solucio analitica',3);
xlabel('llarg (m)');
ylabel('Moment flector (Nxm/m)');
axis tight
titol=sprintf('VIGA 2D: 420x20(cm) Solucio FEM vs ANALITICA. Elements QUAD.');
title(titol); 
hold off

fig=figure(2);
plot(x_gauss,Q_plot,'bx');
hold on
plot(x_gauss,Q_ana,'g--');
hold on
plot(x_gauss,N_plot,'r+');
hold off
legend('Tallant FEM (pdG)','Tallant sol.analitica','Axil FEM (pdG)',2);
xlabel('llarg (m)');
ylabel('Esforos (N/m)');
axis tight
titol=sprintf('VIGA 2D: 420x20(cm) Solucio FEM vs ANALITICA. Elements QUAD.');
title(titol); 




