function [M_x,M_y]=postpr_placanalitica(llarg,ample,q,M,xy_gauss,placa_type);
%discretitzacio de la llesca en x;
x_discr=linspace(0,llarg,100);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nu=0.3;

if placa_type==1;
term_serie=20;
M1x=(q*x_discr.*(llarg-x_discr))/2;
M1y=nu*M1x;
M2x=0;
M2y=0;
for iterm=1:term_serie
    m=2*iterm-1;
    alfa=(m*pi*ample)/(2*llarg);
    A=-(2*(alfa*tanh(alfa)+2))/(pi^5*m^5*cosh(alfa));
    B=2/(pi^5*m^5*cosh(alfa));
    trig=sin(m*pi*x_discr/llarg);
    serie_x=(q*llarg^2*pi^2)*(m^2*(2*nu*B-(1-nu)*A)*trig);
    serie_y=(q*llarg^2*pi^2)*(m^2*(2*B+(1-nu)*A)*trig);
    M2x=M2x+serie_x;
    M2y=M2y+serie_y;
end
M_x=M1x-M2x;
M_y=M1y-M2y;

end

if placa_type==2;
    aux1=((1/(llarg^2))+(1/(ample^2)));
    aux2=q/((pi^2)*(aux1^2));
    aux3=q/((pi^2)*aux1);
    M_x=aux2*((1/llarg^2)+(nu/ample^2))*sin(pi.*x_discr/llarg);
    M_y=aux2*((nu/llarg^2)+(1/ample^2))*sin(pi.*x_discr/llarg);
end
        
[titol,A]=hdrload('llesca.conec');
elem=A(:,1);
nllesca=length(elem);
[titol,piles]=hdrload('drac_piles.conec');
num_piles=length(piles(:,1));
pila_llesca=[];
k=0;
for illesca=1:nllesca;
    for jpila=1:num_piles
    if elem(illesca)==piles(jpila,1);
        k=k+1;
        pila_llesca(k)=jpila;
    end
    end
end
Mx_llesca=M(pila_llesca,1);
My_llesca=M(pila_llesca,2);
x_gauss=xy_gauss(:,1);
y_gauss=xy_gauss(:,2);

fig=figure(1);
subplot(1,2,1)
plot(x_discr,-M_x,'k--');
hold on
plot(x_gauss(pila_llesca),Mx_llesca,'rx');
legend('Solucio analitica','Valors de calcul FEM',1);
xlabel('llarg (m)');
ylabel('Moment X (Nxm/m)');
axis tight
titol=sprintf('Placa 420x420x20 (cm). \n Llei de MOMENTS X per la franja CENTRAL.');
title(titol); 
Mx_max_fem= sprintf('MOMENT X MAX   (calcul): %10.2f N/m/m',abs(min(Mx_llesca)));
Mx_max_ana= sprintf('MOMENT X MAX (analitic): %10.2f Nxm/m',max(M_x));
text(1,-2500,{Mx_max_ana,Mx_max_fem},'FontName','arial','Fontsize',8);
hold off

subplot(1,2,2)
plot(x_discr,-M_y,'b--');
hold on
plot(x_gauss(pila_llesca),My_llesca,'gx');
legend('Solucio analitica','Valors de calcul FEM',1);
xlabel('llarg (m)');
ylabel('Moment Y (Nxm/m)');
axis tight
titol=sprintf('Placa 420x420x20 (cm). \n Llei de MOMENTS Y per la franja CENTRAL.');
title(titol); 
My_max_fem= sprintf('MOMENT Y MAX  (calcul) : %10.2f N/m/m',abs(min(My_llesca)));
My_max_ana= sprintf('MOMENT Y MAX (analitic): %10.2f Nxm/m',max(M_y));
text(1,-2500,{My_max_ana,My_max_fem},'FontName','arial','Fontsize',8);
hold off
