clear all;
%carreguem les diferents matrius dels arxius DRAC
disp('WARNING!! verificar el GRUIX de la lamina');
incr=input('stage step load_incr ?: ');
str_file_gauss=sprintf('gauss_%s.prsm',incr);
[titol,A]=hdrload(str_file_gauss);
gruix=input('gruix de la lamina: ');
num_prism=(length(A(:,1)))/2;
for i=1:num_prism
    gauss_elem1(i,:)=A(2*i-1,2:4);
    gauss_elem2(i,:)=A(2*i,2:4);
    tensio_elem1(i,:)=A(2*i-1,5:10);
    tensio_elem2(i,:)=A(2*i,5:10);
end
[titol,piles]=hdrload('drac_piles.conec');
num_piles=length(piles(:,1));
elemppila=length(piles(1,:));
puntsppila=2*elemppila;
%Obre arxius per escriure els resultats;
str_file01=sprintf('axils_MM_%s.res',incr);
str_file02=sprintf('moments_MM_%s.res',incr);
str_file03=sprintf('tallant_V_%s.res',incr);

f1=fopen(str_file01,'w');
fprintf(f1,'Components AXIL principals i direccions 3D_eixos GLOBALS\r\n');
f2=fopen(str_file02,'w');
fprintf(f2,'Components MOMENT principals i direccions 3D_eixos GLOBALS\r\n');
f3=fopen(str_file03,'w');
fprintf(f3,'Components TALLANT eixos LOCALS\r\n');
xy_gauss=[];
for i=1:num_piles
    gauss_pila=zeros(2*elemppila,3);
    tensio_pila=zeros(2*elemppila,6);
    tensio_pila_local=zeros(2*elemppila,6);
    
    for j=1:elemppila
        xy_gauss(i,:)=gauss_elem1(piles(i,j),1:2);      
        gauss_pila(2*j-1,:)  = [gauss_elem1(piles(i,j),:)];
        gauss_pila(2*j,:)    = [gauss_elem2(piles(i,j),:)];
        tensio_pila(2*j-1,:) = [tensio_elem1(piles(i,j),:)];
        tensio_pila(2*j,:)   = [tensio_elem2(piles(i,j),:)];
      
    end
% Definicio dels eixos locals per la pila i.
%primer vector de la base.
n=[ (gauss_pila(2*elemppila,1)-gauss_pila(1,1)) (gauss_pila(2*elemppila,2)-gauss_pila(1,2)) (gauss_pila(2*elemppila,3)-gauss_pila(1,3))];
modul=sqrt(n(1)^2+n(2)^2+n(3)^2);
n_unit=[n(1)/modul n(2)/modul n(3)/modul ];
%segon vector de la base.
if n_unit(2) <= 1-0.0001;
r2=[-n_unit(3) 0 n_unit(1)];
modul=sqrt(r2(1)^2+r2(2)^2+r2(3)^2);
r2_unit=[r2(1)/modul r2(2)/modul r2(3)/modul ];
else
n_unit=[0 1 0];
r2_unit=[0 0 1];
disp(i);
end
%tercer vector de la base.
r3=[(n_unit(2)*r2_unit(3)-n_unit(3)*r2_unit(2)) (n_unit(3)*r2_unit(1)-n_unit(1)*r2_unit(3)) (n_unit(1)*r2_unit(2)-n_unit(2)*r2_unit(1))];
modul=sqrt(r3(1)^2+r3(2)^2+r3(3)^2);
r3_unit=[r3(1)/modul r3(2)/modul r3(3)/modul ];

%matriu de rotacio per la pila i.
R=[n_unit(1) n_unit(2) n_unit(3);
  r2_unit(1) r2_unit(2) r2_unit(3);
  r3_unit(1) r3_unit(2) r3_unit(3)];

%Angles de EULER per el sistema d'eixos LOCAL.
%teta=acos(r3_unit(3));
%psi=acos(r2_unit(3)/sin(teta));
%fi=asin(r3_unit(1)/sin(teta));
%fprintf(f3,'%5i %2.5f %2.5f %2.5f\r\n',i,fi,teta,psi);
%fprintf(f3,'%5i %f %f %f\r\n',i,fi,teta,psi);


%ROTACIO TENSOR DE TENSIONS DE BASE GLOBAL A BASE LOCAL.
for j=1:puntsppila;
    tensio_punt_global=[tensio_pila(j,1) tensio_pila(j,4) tensio_pila(j,6);
                        tensio_pila(j,4) tensio_pila(j,2) tensio_pila(j,5);
                        tensio_pila(j,6) tensio_pila(j,5) tensio_pila(j,3)];
   tensio_punt_local=R*tensio_punt_global*R';
   tensio_pila_local(j,:)=[tensio_punt_local(1,1) tensio_punt_local(2,2) tensio_punt_local(3,3) tensio_punt_local(1,2) tensio_punt_local(2,3) tensio_punt_local(1,3)];
end

%INTEGRACIO NUMERICA PER TROBAR ELS ESFOROS DE LAMINA.
%Esforos de membrana N_r2, N_r3, N_r2r3
[N_pila,M_pila,Q_pila]=esfor_lamina(tensio_pila_local,elemppila,gruix);

N(i,:)=[(N_pila(:,1)+N_pila(:,2)+N_pila(:,3))'];
M(i,:)=[(M_pila(:,1)+M_pila(:,2)+M_pila(:,3))'];
Q(i,:)=[(Q_pila(:,1)+Q_pila(:,2)+Q_pila(:,3))'];

N_local=[N(i,1) N(i,3);
         N(i,3) N(i,2)];
M_local=[M(i,1) M(i,3);
         M(i,3) M(i,2)];
[vect_N,N_12]=eig(N_local);
[vect_M,M_12]=eig(M_local);

N3D_main=[0 0 0;0 N_12(1,:);0 N_12(2,:)];
M3D_main=[0 0 0;0 M_12(1,:);0 M_12(2,:)];

vepps_N3D_nr2r3=[1 0 0;0 vect_N(:,1)';0 vect_N(:,2)']';
vepps_M3D_nr2r3=[1 0 0;0 vect_M(:,1)';0 vect_M(:,2)']';

diagonal_N=diag(N3D_main);
diagonal_M=diag(M3D_main);

[vapps_N,index_N]=sort(diagonal_N);
[vapps_M,index_M]=sort(diagonal_M);
vapp3N=diagonal_N(index_N(1));
vapp2N=diagonal_N(index_N(2));
vapp1N=diagonal_N(index_N(3));
vapp3M=diagonal_M(index_M(1));
vapp2M=diagonal_M(index_M(2));
vapp1M=diagonal_M(index_M(3));


v3N_nr2r3=vepps_N3D_nr2r3(:,index_N(1));
v2N_nr2r3=vepps_N3D_nr2r3(:,index_N(2));
v1N_nr2r3=vepps_N3D_nr2r3(:,index_N(3));

v3M_nr2r3=vepps_M3D_nr2r3(:,index_M(1));
v2M_nr2r3=vepps_M3D_nr2r3(:,index_M(2));
v1M_nr2r3=vepps_M3D_nr2r3(:,index_M(3));

v3N_xyz=R'*v3N_nr2r3;
v2N_xyz=R'*v2N_nr2r3;
v1N_xyz=R'*v1N_nr2r3;
v3M_xyz=R'*v3M_nr2r3;
v2M_xyz=R'*v2M_nr2r3;
v1M_xyz=R'*v1M_nr2r3;
%fprintf(f1,'%5i %f %f %f %f %f %f %f %f %f %f %f %f \r\n',i,vapps_N',v1N_xyz',v2N_xyz',v3N_xyz');
%fprintf(f3,'%5i %f %f %f \r\n',i,r3_unit);

%N_local_rot=[0 0 0; 0 N_local(1,:);0 N_local(2,:)];
%M_local_rot=[0 0 0; 0 M_local(1,:);0 M_local(2,:)];
%N_global=R'*N_local_rot*R;
%M_global=R'*M_local_rot*R;
%N_3D(i,:)=[N_global(1,1) N_global(2,2) N_global(3,3) N_global(1,2) N_global(2,3) N_global(1,3)];
%M_3D(i,:)=[M_global(1,1) M_global(2,2) M_global(3,3) M_global(1,2) M_global(2,3) M_global(1,3)];
%fprintf(f1,'%7i %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e\r\n',i,N_3D(i,:));
%fprintf(f2,'%7i %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e\r\n',i,M_3D(i,:));
%fprintf(f2,'%7i %f %f %f \r\n',i,M(i,:));
fprintf(f1,'%5i %f %f %f %f %f %f %f %f %f %f %f %f \r\n',i,vapp1N,vapp2N,vapp3N,v1N_xyz',v2N_xyz',v3N_xyz');
fprintf(f2,'%5i %f %f %f %f %f %f %f %f %f %f %f %f \r\n',i,vapp1M,vapp2M,vapp3M,v1M_xyz',v2M_xyz',v3M_xyz');
fprintf(f3,'%5i %f %f %f \r\n',i,Q(i,1),Q(i,2),0);

end
%fprintf(f1,'%5i %f %f %f %f %f %f %f %f %f %f %f %f \r\n',i,vapp1M,vapp2M,vapp3M,v1M_xyz',v2M_xyz',v3M_xyz');
fclose(f1);
fclose(f2);
fclose(f3);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a=input('es representa solucio analitica placa rectangular? car.distr. uniforme[1],sinusoidal[2], no[0]: ');
    llarg=4.2;
    ample=4.2;
    q=5000;
    if (a==1 | a==2);
    [M_x,M_y]=postpr_placanalitica(llarg,ample,q,M,xy_gauss,a);
fid4=fopen('M_ppanlitic.res','w');
for ipila=1:num_piles
    fprintf(fid4,'%5i %f %f %f \r\n',ipila,M(ipila,:));
end
fclose(fid4);
     end
